<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: ring_buffer/ring_buffer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_17d4747e903b79d80b56a3ed98fbfc0f.html">ring_buffer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ring_buffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="ring__buffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef RING_BUFFER_H</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define RING_BUFFER_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef RB_TYPE</span></div><div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">   10</a></span>&#160;<span class="preprocessor">    #define RB_TYPE uint32_t</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//#define RING_BUFFER_HEADER_ONLY</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifdef RING_BUFFER_HEADER_ONLY</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">    #define RING_BUFFER_SPEC static inline</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">   19</a></span>&#160;<span class="preprocessor">    #define RING_BUFFER_SPEC</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structring__buffer.html">   24</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structring__buffer.html">ring_buffer</a> {</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="structring__buffer.html#aab5081f441287194b6a8379175ea7b2b">   25</a></span>&#160;    <a class="code" href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">RB_TYPE</a>* <a class="code" href="structring__buffer.html#aab5081f441287194b6a8379175ea7b2b">buffer</a>;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structring__buffer.html#a391c992c66c3e5540265a85ec2b9216a">   26</a></span>&#160;    uint32_t <a class="code" href="structring__buffer.html#a391c992c66c3e5540265a85ec2b9216a">capacity</a>;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structring__buffer.html#a86988a65e0d3ece7990c032c159786d6">   27</a></span>&#160;    uint32_t <a class="code" href="structring__buffer.html#a86988a65e0d3ece7990c032c159786d6">count</a>;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="structring__buffer.html#a0a71cf941cf2509857d61e1443ad8eaa">   28</a></span>&#160;    uint32_t <a class="code" href="structring__buffer.html#a0a71cf941cf2509857d61e1443ad8eaa">read</a>;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="structring__buffer.html#ac4c9f9c5eac363cc22ecc18669cc3891">   29</a></span>&#160;    uint32_t <a class="code" href="structring__buffer.html#ac4c9f9c5eac363cc22ecc18669cc3891">write</a>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;} <a class="code" href="ring__buffer_8h.html#a963a1a53bdd33928539cf4fdea3f40f9">ring_buffer_t</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<a class="code" href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">RING_BUFFER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="ring__buffer_8h.html#a653a84309e2deed3f51accbc2bc994f8">rb_init</a>(<a class="code" href="structring__buffer.html">ring_buffer_t</a>* rb, <a class="code" href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">RB_TYPE</a>* <a class="code" href="structring__buffer.html#aab5081f441287194b6a8379175ea7b2b">buffer</a>, uint32_t length);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<a class="code" href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">RING_BUFFER_SPEC</a> <span class="keywordtype">int</span> <a class="code" href="ring__buffer_8h.html#a0789028e3edc48a3f93cb1f2a2639007">rb_read</a>(<a class="code" href="structring__buffer.html">ring_buffer_t</a>* rb, <a class="code" href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">RB_TYPE</a>* value);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<a class="code" href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">RING_BUFFER_SPEC</a> <span class="keywordtype">int</span> <a class="code" href="ring__buffer_8h.html#a9d433447b1686d4eeec3d6aa34a65e3c">rb_write</a>(<a class="code" href="structring__buffer.html">ring_buffer_t</a>* rb, <a class="code" href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">RB_TYPE</a> value);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<a class="code" href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">RING_BUFFER_SPEC</a> uint32_t <a class="code" href="ring__buffer_8h.html#acca88893dc01c26516b20e5a3c60e88a">rb_get_count</a>(<a class="code" href="structring__buffer.html">ring_buffer_t</a>* rb);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#ifdef RING_BUFFER_HEADER_ONLY</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">    #include &quot;<a class="code" href="ring__buffer_8c.html">ring_buffer.c</a>&quot;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structring__buffer_html_a0a71cf941cf2509857d61e1443ad8eaa"><div class="ttname"><a href="structring__buffer.html#a0a71cf941cf2509857d61e1443ad8eaa">ring_buffer::read</a></div><div class="ttdeci">uint32_t read</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:28</div></div>
<div class="ttc" id="ring__buffer_8h_html_a0c18775e0bc3e273e024d969e91d63a1"><div class="ttname"><a href="ring__buffer_8h.html#a0c18775e0bc3e273e024d969e91d63a1">RING_BUFFER_SPEC</a></div><div class="ttdeci">#define RING_BUFFER_SPEC</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:19</div></div>
<div class="ttc" id="ring__buffer_8h_html_af72901092687a69d9997872b8b25df60"><div class="ttname"><a href="ring__buffer_8h.html#af72901092687a69d9997872b8b25df60">RB_TYPE</a></div><div class="ttdeci">#define RB_TYPE</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:10</div></div>
<div class="ttc" id="ring__buffer_8h_html_a963a1a53bdd33928539cf4fdea3f40f9"><div class="ttname"><a href="ring__buffer_8h.html#a963a1a53bdd33928539cf4fdea3f40f9">ring_buffer_t</a></div><div class="ttdeci">struct ring_buffer ring_buffer_t</div></div>
<div class="ttc" id="structring__buffer_html_ac4c9f9c5eac363cc22ecc18669cc3891"><div class="ttname"><a href="structring__buffer.html#ac4c9f9c5eac363cc22ecc18669cc3891">ring_buffer::write</a></div><div class="ttdeci">uint32_t write</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:29</div></div>
<div class="ttc" id="structring__buffer_html_a391c992c66c3e5540265a85ec2b9216a"><div class="ttname"><a href="structring__buffer.html#a391c992c66c3e5540265a85ec2b9216a">ring_buffer::capacity</a></div><div class="ttdeci">uint32_t capacity</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:26</div></div>
<div class="ttc" id="structring__buffer_html_aab5081f441287194b6a8379175ea7b2b"><div class="ttname"><a href="structring__buffer.html#aab5081f441287194b6a8379175ea7b2b">ring_buffer::buffer</a></div><div class="ttdeci">RB_TYPE * buffer</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:25</div></div>
<div class="ttc" id="ring__buffer_8h_html_a9d433447b1686d4eeec3d6aa34a65e3c"><div class="ttname"><a href="ring__buffer_8h.html#a9d433447b1686d4eeec3d6aa34a65e3c">rb_write</a></div><div class="ttdeci">RING_BUFFER_SPEC int rb_write(ring_buffer_t *rb, RB_TYPE value)</div><div class="ttdef"><b>Definition:</b> ring_buffer.c:35</div></div>
<div class="ttc" id="ring__buffer_8h_html_a0789028e3edc48a3f93cb1f2a2639007"><div class="ttname"><a href="ring__buffer_8h.html#a0789028e3edc48a3f93cb1f2a2639007">rb_read</a></div><div class="ttdeci">RING_BUFFER_SPEC int rb_read(ring_buffer_t *rb, RB_TYPE *value)</div><div class="ttdef"><b>Definition:</b> ring_buffer.c:20</div></div>
<div class="ttc" id="ring__buffer_8c_html"><div class="ttname"><a href="ring__buffer_8c.html">ring_buffer.c</a></div></div>
<div class="ttc" id="ring__buffer_8h_html_acca88893dc01c26516b20e5a3c60e88a"><div class="ttname"><a href="ring__buffer_8h.html#acca88893dc01c26516b20e5a3c60e88a">rb_get_count</a></div><div class="ttdeci">RING_BUFFER_SPEC uint32_t rb_get_count(ring_buffer_t *rb)</div><div class="ttdef"><b>Definition:</b> ring_buffer.c:49</div></div>
<div class="ttc" id="ring__buffer_8h_html_a653a84309e2deed3f51accbc2bc994f8"><div class="ttname"><a href="ring__buffer_8h.html#a653a84309e2deed3f51accbc2bc994f8">rb_init</a></div><div class="ttdeci">RING_BUFFER_SPEC void rb_init(ring_buffer_t *rb, RB_TYPE *buffer, uint32_t length)</div><div class="ttdef"><b>Definition:</b> ring_buffer.c:8</div></div>
<div class="ttc" id="structring__buffer_html"><div class="ttname"><a href="structring__buffer.html">ring_buffer</a></div><div class="ttdef"><b>Definition:</b> ring_buffer.h:24</div></div>
<div class="ttc" id="structring__buffer_html_a86988a65e0d3ece7990c032c159786d6"><div class="ttname"><a href="structring__buffer.html#a86988a65e0d3ece7990c032c159786d6">ring_buffer::count</a></div><div class="ttdeci">uint32_t count</div><div class="ttdef"><b>Definition:</b> ring_buffer.h:27</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
